'use strict';chai.config.includeStack=!0,chai.config.truncateThreshold=0,describe('jujulib payment service',function(){let a,b;const c=function(d,e=!0){return{target:{responseText:e?JSON.stringify(d):d}}};beforeEach(function(){b={nickname:'spinach',name:'Geoffrey Spinach',email:'spinach@example.com',business:!0,addresses:[{id:'address1',city:'New Orleans',postcode:'70130'}],vat:'1234',"business-name":'Spinachy business',"billing-addresses":[{id:'address2',city:'New Orleans',postcode:'70130'}],"payment-methods":[{address:{id:'address3',name:null,line1:null,line2:null,county:'Bunnyhug',city:'New Orleans',postcode:null,country:null,phones:[]},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',"card-holder":'Mr G Spinach',valid:!0,year:2017}],"allow-email":!0,valid:!0},a={nickname:'spinach',name:'Geoffrey Spinach',email:'spinach@example.com',business:!0,addresses:[{id:'address1',name:null,line1:null,line2:null,name:null,city:'New Orleans',county:null,postcode:'70130',country:null,phones:[]}],vat:'1234',businessName:'Spinachy business',billingAddresses:[{id:'address2',name:null,line1:null,line2:null,name:null,city:'New Orleans',county:null,postcode:'70130',country:null,phones:[]}],paymentMethods:[{address:{id:'address3',name:null,line1:null,line2:null,state:'Bunnyhug',city:'New Orleans',postcode:null,country:null},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',cardHolder:'Mr G Spinach',valid:!0,year:2017}],allowEmail:!0,valid:!0}}),it('exists',function(){const e=new window.jujulib.payment('http://1.2.3.4/',{});assert.strictEqual(e instanceof window.jujulib.payment,!0),assert.strictEqual(e.url,`http://1.2.3.4/${window.jujulib.paymentAPIVersion}`)}),it('can get a user',function(d){const f=new window.jujulib.payment('http://1.2.3.4/',{get:function(g,h,i){assert.equal(g,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach');const j=c(b);i(null,j)}});f.getUser('spinach',function(g,h){assert.strictEqual(g,null),assert.deepEqual(h,a),d()})}),it('can handle missing fields when getting a user',function(d){const f=new window.jujulib.payment('http://1.2.3.4/',{get:function(g,h,i){assert.equal(g,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach');const j=c({"billing-addresses":[{id:'address2',city:'New Orleans'}],"payment-methods":[{address:{id:'address3',city:'New Orleans'},id:'paymentmethod1'}]});i(null,j)}});f.getUser('spinach',function(g,h){assert.strictEqual(g,null),assert.deepEqual(h,{nickname:null,name:null,email:null,business:!1,addresses:[],vat:null,businessName:null,billingAddresses:[{id:'address2',name:null,line1:null,line2:null,name:null,city:'New Orleans',county:null,postcode:null,country:null,phones:[]}],paymentMethods:[{address:{id:'address3',name:null,line1:null,line2:null,state:null,city:'New Orleans',postcode:null,country:null},id:'paymentmethod1',brand:null,last4:null,month:null,name:null,cardHolder:null,valid:!1,year:null}],allowEmail:!1,valid:!1}),d()})}),it('handles errors when getting a user',function(d){const f=new window.jujulib.payment('http://1.2.3.4/',{get:function(g,h,i){const j=c({Error:'Uh oh!'});i(null,j)}});f.getUser('spinach',function(g,h){assert.equal(g,'Uh oh!'),assert.strictEqual(h,null),d()})}),it('can create a user',function(){const d={put:sinon.stub()},e=new window.jujulib.payment('http://1.2.3.4/',d);e.createUser({name:'Geoffrey Spinach',email:'spinach@example.com',addresses:[{city:'New Orleans',postcode:'70130'}],vat:'1234',business:!0,businessName:'Spinachy business',billingAddresses:[{city:'New Orleans',postcode:'70130',country:'US'}],allowEmail:!0,token:'54321'},sinon.stub()),assert.deepEqual(JSON.parse(d.put.args[0][2]),{name:'Geoffrey Spinach',email:'spinach@example.com',addresses:[{name:null,line1:null,line2:null,city:'New Orleans',county:null,postcode:'70130',"country-code":null,phones:[]}],vat:'1234',business:!0,"business-name":'Spinachy business',"billing-addresses":[{name:null,line1:null,line2:null,city:'New Orleans',county:null,postcode:'70130',"country-code":'US',phones:[]}],"allow-email":!0,token:'54321',"payment-method-name":null})}),it('can return the user when after creating a user',function(){const e=new window.jujulib.payment('http://1.2.3.4/',{put:function(g,h,i,j){assert.equal(g,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u');const k=c(b);j(null,k)}});e.createUser({name:'Geoffrey Spinach',email:'spinach@example.com',addresses:[{id:'address1',city:'New Orleans',postcode:'70130'}],vat:'1234',business:!0,businessName:'Spinachy business',billingAddresses:[{id:'address2',city:'New Orleans',postcode:'70130'}],allowEmail:!0,token:'54321'},function(g,h){assert.strictEqual(g,null),assert.deepEqual(h,a)})}),it('handles errors when creating a user',function(d){const f=new window.jujulib.payment('http://1.2.3.4/',{put:function(g,h,i,j){const k=c({Error:'Uh oh!'});j(null,k)}});f.createUser({},function(g,h){assert.equal(g,'Uh oh!'),assert.strictEqual(h,null),d()})}),it('can get a list of countries',function(d){const e=[{name:'Australia',code:'AU'}],g=new window.jujulib.payment('http://1.2.3.4/',{get:(h,i,j)=>{assert.equal(h,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/country');const k=c({countries:e});j(null,k)}});g.getCountries((h,i)=>{assert.strictEqual(h,null),assert.deepEqual(i,e),d()})}),it('handles errors when getting the country list',function(d){const f=new window.jujulib.payment('http://1.2.3.4/',{get:(g,h,i)=>{const j=c({Error:'Uh oh!'});i(null,j)}});f.getCountries((g,h)=>{assert.equal(g,'Uh oh!'),assert.strictEqual(h,null),d()})}),describe('getPaymentMethods',()=>{it('can get payment methods for a user',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{get:function(g,h,i){assert.equal(g,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/payment-methods');const j=c({"payment-methods":[{address:{id:'address1',name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',"card-holder":'Mr G Spinach',valid:!0,year:2017}]});i(null,j)}});f.getPaymentMethods('spinach',function(g,h){assert.strictEqual(g,null),assert.deepEqual(h,[{address:{id:'address1',name:'Home',line1:'1 Maple St',line2:null,state:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',cardHolder:'Mr G Spinach',valid:!0,year:2017}]),d()})}),it('handles errors when getting a user',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{get:function(g,h,i){const j=c({Message:'Uh oh!'});i(null,j)}});f.getPaymentMethods('spinach',function(g,h){assert.equal(g,'Uh oh!'),assert.strictEqual(h,null),d()})})}),describe('createPaymentMethod',()=>{it('can create a payment method',()=>{const d={put:sinon.stub()},e=new window.jujulib.payment('http://1.2.3.4/',d);e.createPaymentMethod('spinach','token123','Business',sinon.stub()),assert.equal(d.put.callCount,1),assert.deepEqual(d.put.args[0][2],JSON.stringify({"payment-method-name":'Business',token:'token123'}))}),it('can return the payment method when it has been created',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{put:function(g,h,i,j){assert.equal(g,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/payment-methods');const k=c({address:{id:'address1',name:'Home',line1:'1 Maple St',line2:'Loonie Lane',county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',"card-holder":'Mr G Spinach',valid:!0,year:2017});j(null,k)}});f.createPaymentMethod('spinach','token123',null,(g,h)=>{assert.strictEqual(g,null),assert.deepEqual(h,{address:{id:'address1',name:'Home',line1:'1 Maple St',line2:'Loonie Lane',state:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',cardHolder:'Mr G Spinach',valid:!0,year:2017}),d()})}),it('handles errors when creating a payment method',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{put:function(g,h,i,j){const k=c({Message:'Uh oh!'});j(null,k)}});f.createPaymentMethod('spinach','token123',null,(g,h)=>{assert.equal(g,'Uh oh!'),assert.strictEqual(h,null),d()})})}),describe('updatePaymentMethod',()=>{it('can update a payment method',()=>{const d={put:sinon.stub()},e=new window.jujulib.payment('http://1.2.3.4/',d);e.updatePaymentMethod('spinach','paymentmethod1',{line1:'10 Maple St',line2:'',city:'Sasquatch',county:'Bunnyhug',postcode:'90210',country:'CA'},'12/17',sinon.stub()),assert.equal(d.put.callCount,1),assert.deepEqual(d.put.args[0][2],JSON.stringify({address:{name:null,line1:'10 Maple St',line2:null,city:'Sasquatch',county:'Bunnyhug',postcode:'90210',"country-code":'CA',phones:[]},month:12,year:17}))}),it('can return when there are no errors',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{put:function(g,h,i,j){assert.equal(g,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/payment-methods/paymentmethod1');const k=c('success');j(null,k)}});f.updatePaymentMethod('spinach','paymentmethod1',{},'12/17',(g)=>{assert.strictEqual(g,null),d()})}),it('handles errors when updating a payment method',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{put:function(g,h,i,j){const k=c({Message:'Uh oh!'});j(null,k)}});f.updatePaymentMethod('spinach','paymentmethod1',{},'12/17',(g)=>{assert.equal(g,'Uh oh!'),d()})})}),describe('removePaymentMethod',()=>{it('can remove a payment method',()=>{const d={delete:sinon.stub()},e=new window.jujulib.payment('http://1.2.3.4/',d);e.removePaymentMethod('spinach','paymentmethod1',sinon.stub()),assert.equal(d.delete.callCount,1),assert.deepEqual(d.delete.args[0][2],JSON.stringify({"payment-method-name":'paymentmethod1'}))}),it('can return when there are no errors',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{delete:function(g,h,i,j){assert.equal(g,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/payment-methods/paymentmethod1');const k=c('success');j(null,k)}});f.removePaymentMethod('spinach','paymentmethod1',(g)=>{assert.strictEqual(g,null),d()})}),it('handles errors when removing a payment method',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{delete:function(g,h,i,j){const k=c({error:'Uh oh!'});j(null,k)}});f.removePaymentMethod('spinach','paymentmethod1',(g)=>{assert.equal(g,'Uh oh!'),d()})})}),describe('addAddress',()=>{let d;beforeEach(()=>{d={name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'CA'}}),it('can add an address',()=>{const e={put:sinon.stub()},f=new window.jujulib.payment('http://1.2.3.4/',e);f.addAddress('spinach',d,sinon.stub()),assert.equal(e.put.callCount,1),assert.deepEqual(e.put.args[0][2],JSON.stringify({name:'Home',line1:'1 Maple St',line2:null,city:'Sasquatch',county:'Bunnyhug',postcode:'90210',"country-code":'CA',phones:[]}))}),it('can successfully create the address',(e)=>{const g=new window.jujulib.payment('http://1.2.3.4/',{put:function(h,i,j,k){assert.equal(h,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/addresses');const l=c();k(null,l)}});g.addAddress('spinach',d,(h)=>{assert.strictEqual(h,null),e()})}),it('handles errors when adding an address',(e)=>{const g=new window.jujulib.payment('http://1.2.3.4/',{put:function(h,i,j,k){const l=c({Message:'Uh oh!'});k(null,l)}});g.addAddress('spinach',d,(h)=>{assert.equal(h,'Uh oh!'),e()})})}),describe('addBillingAddress',()=>{let d;beforeEach(()=>{d={name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'CA'}}),it('can add a billing address',()=>{const e={put:sinon.stub()},f=new window.jujulib.payment('http://1.2.3.4/',e);f.addBillingAddress('spinach',d,sinon.stub()),assert.equal(e.put.callCount,1),assert.deepEqual(e.put.args[0][2],JSON.stringify({name:'Home',line1:'1 Maple St',line2:null,city:'Sasquatch',county:'Bunnyhug',postcode:'90210',"country-code":'CA',phones:[]}))}),it('can successfully create the billing address',(e)=>{const g=new window.jujulib.payment('http://1.2.3.4/',{put:function(h,i,j,k){assert.equal(h,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/billing-addresses');const l=c();k(null,l)}});g.addBillingAddress('spinach',d,(h)=>{assert.strictEqual(h,null),e()})}),it('handles errors when adding a billing address',(e)=>{const g=new window.jujulib.payment('http://1.2.3.4/',{put:function(h,i,j,k){const l=c({Message:'Uh oh!'});k(null,l)}});g.addBillingAddress('spinach',d,(h)=>{assert.equal(h,'Uh oh!'),e()})})}),describe('removeAddress',()=>{it('can remove an address',()=>{const d={delete:sinon.stub()},e=new window.jujulib.payment('http://1.2.3.4/',d);e.removeAddress('spinach','address1',sinon.stub()),assert.equal(d.delete.callCount,1),assert.strictEqual(d.delete.args[0][2],null)}),it('can return when there are no errors',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{delete:function(g,h,i,j){assert.equal(g,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/addresses/address1');const k=c('success');j(null,k)}});f.removeAddress('spinach','address1',(g)=>{assert.strictEqual(g,null),d()})}),it('handles errors when removing an address',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{delete:function(g,h,i,j){const k=c({error:'Uh oh!'});j(null,k)}});f.removeAddress('spinach','address1',(g)=>{assert.equal(g,'Uh oh!'),d()})})}),describe('removeBillingAddress',()=>{it('can remove a biling address',()=>{const d={delete:sinon.stub()},e=new window.jujulib.payment('http://1.2.3.4/',d);e.removeBillingAddress('spinach','address1',sinon.stub()),assert.equal(d.delete.callCount,1),assert.strictEqual(d.delete.args[0][2],null)}),it('can return when there are no errors',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{delete:function(g,h,i,j){assert.equal(g,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/billing-addresses/address1');const k=c('success');j(null,k)}});f.removeBillingAddress('spinach','address1',(g)=>{assert.strictEqual(g,null),d()})}),it('handles errors when removing a billing address',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{delete:function(g,h,i,j){const k=c({error:'Uh oh!'});j(null,k)}});f.removeBillingAddress('spinach','address1',(g)=>{assert.equal(g,'Uh oh!'),d()})})}),describe('updateAddress',()=>{let d;beforeEach(()=>{d={name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'CA'}}),it('can update an address',()=>{const e={post:sinon.stub()},f=new window.jujulib.payment('http://1.2.3.4/',e);f.updateAddress('spinach','address1',d,sinon.stub()),assert.equal(e.post.callCount,1),assert.deepEqual(JSON.parse(e.post.args[0][2]),{id:'address1',name:'Home',line1:'1 Maple St',line2:null,city:'Sasquatch',county:'Bunnyhug',postcode:'90210',"country-code":'CA',phones:[]})}),it('can successfully update the address',(e)=>{const g=new window.jujulib.payment('http://1.2.3.4/',{post:function(h,i,j,k){assert.equal(h,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/addresses/address1');const l=c();k(null,l)}});g.updateAddress('spinach','address1',d,(h)=>{assert.strictEqual(h,null),e()})}),it('handles errors when updating an address',(e)=>{const g=new window.jujulib.payment('http://1.2.3.4/',{post:function(h,i,j,k){const l=c({Message:'Uh oh!'});k(null,l)}});g.updateAddress('spinach','address1',d,(h)=>{assert.equal(h,'Uh oh!'),e()})})}),describe('updateBillingAddress',()=>{let d;beforeEach(()=>{d={name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'CA'}}),it('can update a billing address',()=>{const e={post:sinon.stub()},f=new window.jujulib.payment('http://1.2.3.4/',e);f.updateBillingAddress('spinach','address1',d,sinon.stub()),assert.equal(e.post.callCount,1),assert.deepEqual(JSON.parse(e.post.args[0][2]),{id:'address1',name:'Home',line1:'1 Maple St',line2:null,city:'Sasquatch',county:'Bunnyhug',postcode:'90210',"country-code":'CA',phones:[]})}),it('can successfully update the billing address',(e)=>{const g=new window.jujulib.payment('http://1.2.3.4/',{post:function(h,i,j,k){assert.equal(h,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/billing-addresses/address1');const l=c();k(null,l)}});g.updateBillingAddress('spinach','address1',d,(h)=>{assert.strictEqual(h,null),e()})}),it('handles errors when updating a billing address',(e)=>{const g=new window.jujulib.payment('http://1.2.3.4/',{post:function(h,i,j,k){const l=c({error:'Uh oh!'});k(null,l)}});g.updateBillingAddress('spinach','address1',d,(h)=>{assert.equal(h,'Uh oh!'),e()})})}),describe('getCharges',()=>{it('can get a list of charges',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{post:function(g,h,i,j){assert.equal(g,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/charges');const k=c({charges:[{id:'TEST-12344',"statement-id":'12344',price:1e4,vat:2e3,currency:'USD',nickname:'spinach',for:'2016-01-02T15:04:05Z',origin:'TEST',state:'done',"line-items":[{name:'this is line 1',details:'a bit more details for line 1',usage:'something',price:'48'}],"payment-received-at":'2017-04-28T07:49:39.925Z',"payment-method-used":{address:{id:'address1',name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',"card-holder":'Mr G Spinach',valid:!0,year:2017},"payment-retry-delay":10,"payment-retry-max":2,"payment-method-update-retry-delay":10,"payment-method-update-retry-max":100}]});j(null,k)}});f.getCharges('spinach',(g,h)=>{assert.strictEqual(g,null),assert.deepEqual(h,[{id:'TEST-12344',statementId:'12344',price:1e4,vat:2e3,currency:'USD',nickname:'spinach',for:'2016-01-02T15:04:05Z',origin:'TEST',state:'done',lineItems:[{name:'this is line 1',details:'a bit more details for line 1',usage:'something',price:'48'}],paymentReceivedAt:'2017-04-28T07:49:39.925Z',paymentMethodUsed:{address:{id:'address1',name:'Home',line1:'1 Maple St',line2:null,state:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',cardHolder:'Mr G Spinach',valid:!0,year:2017},paymentRetryDelay:10,paymentRetryMax:2,paymentMethodUpdateRetryDelay:10,paymentMethodUpdateRetryMax:100}]),d()})}),it('handles errors when getting charges',(d)=>{const f=new window.jujulib.payment('http://1.2.3.4/',{post:function(g,h,i,j){const k=c({Message:'Uh oh!'});j(null,k)}});f.getCharges('spinach',(g,h)=>{assert.equal(g,'Uh oh!'),assert.strictEqual(h,null),d()})})}),describe('getReceipt',()=>{it('can get a receipt',function(d){const f=new window.jujulib.payment('http://1.2.3.4/',{get:(g,h,i)=>{assert.equal(g,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/receipts/charge123');const j=c('<html>...</html>',!1);i(null,j)}});f.getReceipt('charge123',(g,h)=>{assert.strictEqual(g,null),assert.equal(h,'<html>...</html>'),d()})}),it('handles errors when getting a receipt',function(d){const f=new window.jujulib.payment('http://1.2.3.4/',{get:(g,h,i)=>{const j=c({error:'Uh oh!'});i(null,j)}});f.getReceipt('charge123',(g,h)=>{assert.equal(g,'Uh oh!'),assert.strictEqual(h,null),d()})})})});